/* RXT.CMD - a Rexx/MQ Example */

/* Define the Rexx/MQ interface to Rexx */

rcc = RXFuncadd('RXMQLINIT','RXMQL','RXMQLINIT')
say 'rc=' rcc

/* Initialise the interface */
RXMQLTRACE = ''

rcc= RXMQLINIT()
say 'rc=' rcc

/* Connect to Queue Manager - RAHW */

RXMQLTRACE = ''
rcc = RXMQLCONN("RAHW")
say 'RC=' rcc

/* Open Queue N1 for Inquire Access Only, tracing Object Descriptor accesses */

iod.on = 'N1'
iod.ot = MQOT_Q

RXMQLTRACE = 'BOD MOD'
rcc = RXMQLOPEN('iod.', mqoo_inquire, 'h1', 'ood.')
say 'RC=' rcc  'H=' h1

/* Open Queue P1 for Output and Browse Access, plus Attribute manipulation */

RXMQLTRACE = ''
rcc = RXMQLOPEN('P1', mqoo_inquire+mqoo_output+mqoo_browse+mqoo_set, 'h2', 'ood.')
say 'RC=' rcc  'H=' h2

/* Write a Persistent Message, within UOW, to Queue P1; trace everything */

RXMQLTRACE = 'PUT BMD MMD BPO BPO'
d.0      = 20
d.1      = time() '0123456789'
imd.PER  = MQPER_PERSISTENT
ipmo.opt = MQPMO_SYNCPOINT
rcc      = RXMQLPUT( h2,'d.','imd.','omd.','ipmo.','opmo.')
say 'RC=' rcc

/* Inquire upon the number of Messages now in Queue P1 */

RXMQLTRACE = ''
atrin = mqia_current_q_depth
atrou = ''
rcc   = RXMQLINQ(h2, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'

/* Show the name of the Queue which is using handle 1*/

RXMQLTRACE = ''
atrin = mqca_q_name
atrou = ''
rcc   = RXMQLINQ(h1, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'
/* Toggle the GETtability of a Queue, providing a change each time */

RXMQLTRACE = ''
atrsn = MQIA_INHIBIT_GET
atrsd = MQQA_GET_INHIBITED
rcc   = RXMQLSET(h2, atrsn, atrsd)
say 'RC=' rcc

RXMQLTRACE = ''
atrin = mqia_inhibit_get ; atrou = ''
rcc   = RXMQLINQ(h2, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'

RXMQLTRACE = ''
atrsn = MQIA_INHIBIT_GET
atrsd = MQQA_GET_ALLOWED
rcc   = RXMQLSET(h2, atrsn, atrsd)
say 'RC=' rcc

RXMQLTRACE = ''
atrin = MQIA_INHIBIT_GET ; atrou = ''
rcc = RXMQLINQ(h2, atrin, 'atrou' )
say 'RC=' rcc
say 'Atr' atrin 'Setting <'atrou'>'

/* Set the Trigger Data for a Queue ... */

RXMQLTRACE = ''
atrsn = MQCA_TRIGGER_DATA
atrsd = 'RAH Trigger Data'
rcc   = RXMQLSET(h2, atrsn, atrsd)
say 'RC=' rcc

/* ... and show that it's worked */

RXMQLTRACE = ''
atrin = mqca_trigger_data
atrou = ''
rcc = RXMQLINQ(h2, atrin, 'atrou' )
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'

/* Syncpoint all accesses to the QM */

RXMQLTRACE = ''
rcc = RXMQLCMIT()
say 'RC=' rcc

/* Browse all messages on queue P1, tracing everything, and showing updates */

RXMQLTRACE = 'BGO MGO MMD BMD GET'
do i=1
   g.0      = 200
   g.1      = ''
   igmo.opt = MQGMO_WAIT+MQGMO_BROWSE_NEXT
   rcc = RXMQLGET( h2,'g.','igmd.','ogmd.','igmo.','ogmo.')
   say 'RC=' rcc
   say '...............' i 'data <'g.1'> length' g.0
   say 'ogmd.pd' ogmd.pd 'ogmo.rqn<'ogmo.rqn'>'
   if ( word(rcc,1) = 0 ) then leave
   end

/* Rollback a Unit of Work (empty in this case) */
RXMQLTRACE = ''
rcc = RXMQLBACK()
say 'RC=' rcc

/* Stop access to a Queue */

RXMQLTRACE = ''
rcc = RXMQLCLOSE(h2, mqco_none)
say 'RC=' rcc

/* Re-open the P1 Queue for Browse only access */

RXMQLTRACE = ''
rcc = RXMQLOPEN('P1', mqoo_browse, 'h3', 'ood.')
say 'RC=' rcc  'H=' h3

/* Browse the Queue using the Extension function */
RXMQLTRACE = ''
do i=1
   g.0 = 200
   g.1 = ''
   rcc = RXMQLBROWSE( h3,'g.')
   say 'RC=' rcc
   say '@@@@@@@@@@@@@@@' i 'data <'g.1'> length' g.0
   if ( word(rcc,1) = 0 ) then leave
   end

/* Show the last command used etc. */
say 'Last Message <'RXMQL.LASTMSG'> Last call 'RXMQL.LASTOP,
    ' which ended with RC('RXMQL.LASTRC') and MQCC('RXMQL.LASTCC')',
    ' MQRC('RXMQL.LASTAC')'


/* Issue a Bad command to show effect of -ve RC */
rcc = RXMQLOPEN()
say 'Last Message <'RXMQL.LASTMSG'> Last call 'RXMQL.LASTOP,
    ' which ended with RC('RXMQL.LASTRC') and MQCC('RXMQL.LASTCC')',
    ' MQRC('RXMQL.LASTAC')'

/* Stop access to the Queue */

RXMQLTRACE = ''
rcc = RXMQLCLOSE(h3, mqco_none)
say 'RC=' rcc

/* Disconnect from the QM (Closing h1 in the process) */

RXMQLTRACE = ''
rcc = RXMQLDISC()
say 'RC=' rcc

/* Remove the Interface functions from the Rexx Workspace ... */

RXMQLTRACE = 'TERM'
rcc = RXMQLTERM()
say 'RC=' rcc

/* ... but leave the MQ_ constants around */
say 'MQPER_PERSISTENT' MQPER_PERSISTENT 'RC(2048) is' RXMQL.RCMAP.2048
say 'MQGMO_CONVERT'    MQGMO_CONVERT    '(16384) '

/* End of RXT.CMD exec */
